'**********************************************************
'Compiler            : BASCOM-AVR
'Hardware            : DS1821 an PD.6 (+125 bis -55 Grad)
'                      LC-Display
'Chip type           : AT90S2313
'**********************************************************

$regfile = "2313def.dat"             'AT90S2313
$crystal = 3579545                   'Quarz 3.579MHz

Config 1wire = Portd.6               'DS1821 DQ an PD6

Dim Ar As Byte                       'Variablenname und Typ festlegen
Dim Temperatur As Integer

Lcd "DS1821 an PD.6"                 'Ausgabe des Textes auf LCD
Wait 3                               'warte 3 Sekunden
Cls                                  'lsche LCD
Lcd "Temp:"                          'Ausgabe des Textes auf LCD
Do                                   'Beginn der Schleife
  1wreset                            'Reset DS1821
  1wwrite &HEE                       'starte Temperaturkonvertierung
  Waitms 100                         'warte 100 Millisekunden
  1wreset                            'Reset DS1821
  1wwrite &HAA                       'DS1821 sende Daten an Atmel
  Ar = 1wread()                      'lesen die empfangenen Daten
  1wwrite &H22                       'stop Temperaturkonvertierung
  Locate 2 , 1                       'LCD-Cursor auf Zeile2, Spalte1
  Temperatur = Ar                    'Temperatur bergeben
  If Temperatur > 127 Then           'wenn negative Temperatur
    Lcd "-"                          'dann "Minus" auf LCD ausgeben
    Temperatur = 256 - Temperatur    'und negative Temperatur berechnen
  Else                               'wenn nicht
    Lcd " "                          'dann Leerzeichen auf LCD ausgeben
  End If
  Lcd Temperatur ;                   'Temperatur ausgeben                 
  Lcd " C "                          'Ausgabe des Textes auf LCD
  Wait 1                             'warte 1 Sekunde
Loop                                 'zum Beginn der Schleife 

End